Index: drivers/filesystems/btrfs/search.c
===================================================================
--- drivers/filesystems/btrfs/search.c	(révision 75772)
+++ drivers/filesystems/btrfs/search.c	(copie de travail)
@@ -1,17 +1,17 @@
-/* Copyright (c) Mark Harmstone 2016
- * 
+/* Copyright (c) Mark Harmstone 2016-17
+ *
  * This file is part of WinBtrfs.
- * 
+ *
  * WinBtrfs is free software: you can redistribute it and/or modify
  * it under the terms of the GNU Lesser General Public Licence as published by
  * the Free Software Foundation, either version 3 of the Licence, or
  * (at your option) any later version.
- * 
+ *
  * WinBtrfs is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU Lesser General Public Licence for more details.
- * 
+ *
  * You should have received a copy of the GNU Lesser General Public Licence
  * along with WinBtrfs.  If not, see <http://www.gnu.org/licenses/>. */
 
@@ -23,209 +23,134 @@
 #include <mountmgr.h>
 #include <windef.h>
 #endif
+#include <ntddstor.h>
+#include <ntdddisk.h>
 
 #include <initguid.h>
-#ifndef __REACTOS__
-#include <winioctl.h>
-#endif
 #include <wdmguid.h>
 
-extern LIST_ENTRY volumes;
-extern ERESOURCE volumes_lock;
-extern LIST_ENTRY pnp_disks;
+extern ERESOURCE pdo_list_lock;
+extern LIST_ENTRY pdo_list;
+extern UNICODE_STRING registry_path;
+extern KEVENT mountmgr_thread_event;
+extern HANDLE mountmgr_thread_handle;
+extern BOOL shutting_down;
 
-static NTSTATUS create_part0(PDRIVER_OBJECT DriverObject, PDEVICE_OBJECT DeviceObject, PUNICODE_STRING devpath,
-                             PUNICODE_STRING nameus, BTRFS_UUID* uuid) {
-    PDEVICE_OBJECT newdevobj;
-    UNICODE_STRING name;
+typedef void (*pnp_callback)(PDRIVER_OBJECT DriverObject, PUNICODE_STRING devpath);
+
+extern PDEVICE_OBJECT master_devobj;
+
+static BOOL fs_ignored(BTRFS_UUID* uuid) {
+    UNICODE_STRING path, ignoreus;
     NTSTATUS Status;
-    part0_device_extension* p0de;
-    
-    static const WCHAR part0_suffix[] = L"Btrfs";
-    
-    name.Length = name.MaximumLength = devpath->Length + (wcslen(part0_suffix) * sizeof(WCHAR));
-    name.Buffer = ExAllocatePoolWithTag(PagedPool, name.Length, ALLOC_TAG);
-    if (!name.Buffer) {
-        ERR("out of memory\n");
-        return STATUS_INSUFFICIENT_RESOURCES;
-    }
-    
-    RtlCopyMemory(name.Buffer, devpath->Buffer, devpath->Length);
-    RtlCopyMemory(&name.Buffer[devpath->Length / sizeof(WCHAR)], part0_suffix, wcslen(part0_suffix) * sizeof(WCHAR));
-    
-    Status = IoCreateDevice(DriverObject, sizeof(part0_device_extension), &name, FILE_DEVICE_DISK, FILE_DEVICE_SECURE_OPEN, FALSE, &newdevobj);
-    if (!NT_SUCCESS(Status)) {
-        ERR("IoCreateDevice returned %08x\n", Status);
-        ExFreePool(name.Buffer);
-        return Status;
-    }
-    
-    p0de = newdevobj->DeviceExtension;
-    p0de->type = VCB_TYPE_PARTITION0;
-    p0de->devobj = DeviceObject;
-    RtlCopyMemory(&p0de->uuid, uuid, sizeof(BTRFS_UUID));
-    
-    p0de->name.Length = name.Length;
-    p0de->name.MaximumLength = name.MaximumLength;
-    p0de->name.Buffer = ExAllocatePoolWithTag(PagedPool, p0de->name.MaximumLength, ALLOC_TAG);
-    
-    if (!p0de->name.Buffer) {
-        ERR("out of memory\b");
-        ExFreePool(name.Buffer);
-        ExFreePool(p0de->name.Buffer);
-        IoDeleteDevice(newdevobj);
-        return STATUS_INSUFFICIENT_RESOURCES;
-    }
-    
-    RtlCopyMemory(p0de->name.Buffer, name.Buffer, name.Length);
-    
-    ObReferenceObject(DeviceObject);
-    
-    newdevobj->StackSize = DeviceObject->StackSize + 1;
-    newdevobj->SectorSize = DeviceObject->SectorSize;
-    
-    newdevobj->Flags |= DO_DIRECT_IO;
-    newdevobj->Flags &= ~DO_DEVICE_INITIALIZING;
-    
-    *nameus = name;
-    
-    return STATUS_SUCCESS;
-}
+    OBJECT_ATTRIBUTES oa;
+    KEY_VALUE_FULL_INFORMATION* kvfi;
+    ULONG dispos, retlen, kvfilen, i, j;
+    HANDLE h;
+    BOOL ret = FALSE;
 
-void add_volume(PDEVICE_OBJECT mountmgr, PUNICODE_STRING us) {
-    ULONG tnsize;
-    MOUNTMGR_TARGET_NAME* tn;
-    KEVENT Event;
-    IO_STATUS_BLOCK IoStatusBlock;
-    PIRP Irp;
-    NTSTATUS Status;
-    ULONG mmdltsize;
-    MOUNTMGR_DRIVE_LETTER_TARGET* mmdlt;
-    MOUNTMGR_DRIVE_LETTER_INFORMATION mmdli;
-    
-    TRACE("found BTRFS volume\n");
-    
-    tnsize = sizeof(MOUNTMGR_TARGET_NAME) - sizeof(WCHAR) + us->Length;
-    tn = ExAllocatePoolWithTag(NonPagedPool, tnsize, ALLOC_TAG);
-    if (!tn) {
+    path.Length = path.MaximumLength = registry_path.Length + (37 * sizeof(WCHAR));
+
+    path.Buffer = ExAllocatePoolWithTag(PagedPool, path.Length, ALLOC_TAG);
+    if (!path.Buffer) {
         ERR("out of memory\n");
-        return;
+        return FALSE;
     }
-    
-    tn->DeviceNameLength = us->Length;
-    RtlCopyMemory(tn->DeviceName, us->Buffer, tn->DeviceNameLength);
-    
-    KeInitializeEvent(&Event, NotificationEvent, FALSE);
-    Irp = IoBuildDeviceIoControlRequest(IOCTL_MOUNTMGR_VOLUME_ARRIVAL_NOTIFICATION,
-                                        mountmgr, tn, tnsize, 
-                                        NULL, 0, FALSE, &Event, &IoStatusBlock);
-    if (!Irp) {
-        ERR("%.*S: IoBuildDeviceIoControlRequest 1 failed\n", us->Length / sizeof(WCHAR), us->Buffer);
-        ExFreePool(tn);
-        return;
-    }
 
-    Status = IoCallDriver(mountmgr, Irp);
-    if (Status == STATUS_PENDING) {
-        KeWaitForSingleObject(&Event, Executive, KernelMode, FALSE, NULL);
-        Status = IoStatusBlock.Status;
+    RtlCopyMemory(path.Buffer, registry_path.Buffer, registry_path.Length);
+
+    i = registry_path.Length / sizeof(WCHAR);
+
+    path.Buffer[i] = '\\';
+    i++;
+
+    for (j = 0; j < 16; j++) {
+        path.Buffer[i] = hex_digit((uuid->uuid[j] & 0xF0) >> 4);
+        path.Buffer[i+1] = hex_digit(uuid->uuid[j] & 0xF);
+
+        i += 2;
+
+        if (j == 3 || j == 5 || j == 7 || j == 9) {
+            path.Buffer[i] = '-';
+            i++;
+        }
     }
 
+    InitializeObjectAttributes(&oa, &path, OBJ_CASE_INSENSITIVE | OBJ_KERNEL_HANDLE, NULL, NULL);
+
+    Status = ZwCreateKey(&h, KEY_QUERY_VALUE, &oa, 0, NULL, REG_OPTION_NON_VOLATILE, &dispos);
+
     if (!NT_SUCCESS(Status)) {
-        ERR("%.*S: IoCallDriver 1 returned %08x\n", us->Length / sizeof(WCHAR), us->Buffer, Status);
-        return;
+        TRACE("ZwCreateKey returned %08x\n", Status);
+        ExFreePool(path.Buffer);
+        return FALSE;
     }
-    
-    ExFreePool(tn);
-    
-    mmdltsize = offsetof(MOUNTMGR_DRIVE_LETTER_TARGET, DeviceName[0]) + us->Length;
-    
-    mmdlt = ExAllocatePoolWithTag(NonPagedPool, mmdltsize, ALLOC_TAG);
-    if (!mmdlt) {
+
+    RtlInitUnicodeString(&ignoreus, L"Ignore");
+
+    kvfilen = (ULONG)offsetof(KEY_VALUE_FULL_INFORMATION, Name[0]) + (255 * sizeof(WCHAR));
+    kvfi = ExAllocatePoolWithTag(PagedPool, kvfilen, ALLOC_TAG);
+    if (!kvfi) {
         ERR("out of memory\n");
-        return;
+        ZwClose(h);
+        ExFreePool(path.Buffer);
+        return FALSE;
     }
-    
-    mmdlt->DeviceNameLength = us->Length;
-    RtlCopyMemory(&mmdlt->DeviceName, us->Buffer, us->Length);
-    TRACE("mmdlt = %.*S\n", mmdlt->DeviceNameLength / sizeof(WCHAR), mmdlt->DeviceName);
-    
-    KeInitializeEvent(&Event, NotificationEvent, FALSE);
-    Irp = IoBuildDeviceIoControlRequest(IOCTL_MOUNTMGR_NEXT_DRIVE_LETTER,
-                                        mountmgr, mmdlt, mmdltsize, 
-                                        &mmdli, sizeof(MOUNTMGR_DRIVE_LETTER_INFORMATION), FALSE, &Event, &IoStatusBlock);
-    if (!Irp) {
-        ERR("%.*S: IoBuildDeviceIoControlRequest 2 failed\n", us->Length / sizeof(WCHAR), us->Buffer);
-        return;
-    }
 
-    Status = IoCallDriver(mountmgr, Irp);
-    if (Status == STATUS_PENDING) {
-        KeWaitForSingleObject(&Event, Executive, KernelMode, FALSE, NULL);
-        Status = IoStatusBlock.Status;
+    Status = ZwQueryValueKey(h, &ignoreus, KeyValueFullInformation, kvfi, kvfilen, &retlen);
+    if (NT_SUCCESS(Status)) {
+        if (kvfi->Type == REG_DWORD && kvfi->DataLength >= sizeof(UINT32)) {
+            UINT32* pr = (UINT32*)((UINT8*)kvfi + kvfi->DataOffset);
+
+            ret = *pr;
+        }
     }
 
-    if (!NT_SUCCESS(Status)) {
-        ERR("%.*S: IoCallDriver 2 returned %08x\n", us->Length / sizeof(WCHAR), us->Buffer, Status);
-    } else
-        TRACE("DriveLetterWasAssigned = %u, CurrentDriveLetter = %c\n", mmdli.DriveLetterWasAssigned, mmdli.CurrentDriveLetter);
-    
-    ExFreePool(mmdlt);
+    ZwClose(h);
+    ExFreePool(kvfi);
+    ExFreePool(path.Buffer);
+
+    return ret;
 }
 
-static void STDCALL test_vol(PDRIVER_OBJECT DriverObject, PDEVICE_OBJECT mountmgr, PUNICODE_STRING devpath, DWORD disk_num, DWORD part_num, LIST_ENTRY* volumes) {
-    KEVENT Event;
-    PIRP Irp;
-    IO_STATUS_BLOCK IoStatusBlock;
+static void test_vol(PDEVICE_OBJECT mountmgr, PDEVICE_OBJECT DeviceObject, PUNICODE_STRING devpath,
+                     DWORD disk_num, DWORD part_num, UINT64 length) {
     NTSTATUS Status;
-    PFILE_OBJECT FileObject;
-    PDEVICE_OBJECT DeviceObject;
-    LARGE_INTEGER Offset;
     ULONG toread;
     UINT8* data = NULL;
     UINT32 sector_size;
-    
+
     TRACE("%.*S\n", devpath->Length / sizeof(WCHAR), devpath->Buffer);
-    
-    Status = IoGetDeviceObjectPointer(devpath, FILE_READ_ATTRIBUTES, &FileObject, &DeviceObject);
-    if (!NT_SUCCESS(Status)) {
-        ERR("IoGetDeviceObjectPointer returned %08x\n", Status);
-        return;
-    }
 
     sector_size = DeviceObject->SectorSize;
-    
+
     if (sector_size == 0) {
         DISK_GEOMETRY geometry;
         IO_STATUS_BLOCK iosb;
-        
+
         Status = dev_ioctl(DeviceObject, IOCTL_DISK_GET_DRIVE_GEOMETRY, NULL, 0,
-                        &geometry, sizeof(DISK_GEOMETRY), TRUE, &iosb);
-        
+                           &geometry, sizeof(DISK_GEOMETRY), TRUE, &iosb);
+
         if (!NT_SUCCESS(Status)) {
             ERR("%.*S had a sector size of 0, and IOCTL_DISK_GET_DRIVE_GEOMETRY returned %08x\n",
                 devpath->Length / sizeof(WCHAR), devpath->Buffer, Status);
             goto deref;
         }
-        
+
         if (iosb.Information < sizeof(DISK_GEOMETRY)) {
             ERR("%.*S: IOCTL_DISK_GET_DRIVE_GEOMETRY returned %u bytes, expected %u\n",
                 devpath->Length / sizeof(WCHAR), devpath->Buffer, iosb.Information, sizeof(DISK_GEOMETRY));
         }
-        
+
         sector_size = geometry.BytesPerSector;
-        
+
         if (sector_size == 0) {
             ERR("%.*S had a sector size of 0\n", devpath->Length / sizeof(WCHAR), devpath->Buffer);
             goto deref;
         }
     }
-    
-    KeInitializeEvent(&Event, NotificationEvent, FALSE);
 
-    Offset.QuadPart = superblock_addrs[0];
-    
-    toread = sector_align(sizeof(superblock), sector_size);
+    toread = (ULONG)sector_align(sizeof(superblock), sector_size);
     data = ExAllocatePoolWithTag(NonPagedPool, toread, ALLOC_TAG);
     if (!data) {
         ERR("out of memory\n");
